﻿g_TeleportData = {	
	m_isEnabled = false,
	m_elapsedTime = 0.0,
	Teleport_Cooldown_Time = 0.5,
}

TWO_PI = 2.0 * 3.14159
DEG_TO_RAD = (3.14159 / 180.0)
RAD_TO_DEG = (180.0 / 3.14159)

X_AXIS = hkVector4.new( 1, 0, 0 )
Y_AXIS = hkVector4.new( 0, 1, 0 )
Z_AXIS = hkVector4.new( 0, 0, 1 )

-- clamps an angle to the rangle of [-2PI, 2PI]
function angleDiff( diff )
    if (diff > TWO_PI/2) then diff = diff - TWO_PI end
    if (diff < -TWO_PI/2) then diff = diff + TWO_PI end
    return diff
end

function onUpdateRoot()

	-- 순간이동 cooldown 시간이 지나면 Jiggler 를 활성화 
	if(g_TeleportData.m_isEnabled == true) then	
		g_TeleportData.m_elapsedTime = g_TeleportData.m_elapsedTime + hkbGetTimestep()
		
		if(g_TeleportData.m_elapsedTime > g_TeleportData.Teleport_Cooldown_Time) then
			hkbSetVariable("HipJigglerEnabled", true)
			hkbSetVariable("BustJigglerEnabled", true)
			g_TeleportData.m_isEnabled = false
		end
	end
end

function onEventRoot()

	-- 순간이동 이벤트 발생시 잠시 Jiggler 를 비활성화 
	local event = hkbGetHandleEventName()
	if(event == "onStartTeleport") then
		g_TeleportData.m_isEnabled = true
		g_TeleportData.m_elapsedTime = 0
		hkbSetVariable("HipJigglerEnabled", false)
		hkbSetVariable("BustJigglerEnabled", false)
	end		
end

function onGeneratedMove()
	
	
	local MoveTypeID = hkbGetVariable("MoveTypeID")
	
	if( MoveTypeID == 0 ) then
	
		-- Compute the character angle (cached for efficiency)
		local fwd = hkVector4.new( 1, 0, 0 )
		fwd:setRotatedDir( hkbGetOldWorldFromModel():getRotation(), X_AXIS)
		local angle = math.atan2( fwd[1], fwd[0] )
		
		local lefthanded = hkbGetVariable("LeftHanded")
		angle = angleDiff(hkbGetVariable("GlobalAngle") - angle)
		local turnSpeed = 10.0
		if(lefthanded) then
			turnSpeed = -10.0
		end
		
		local rad = angle * turnSpeed * hkbGetTimestep();
		hkbSetWorldFromModel( hkbGetWorldFromModel() * hkQsTransform.new( Z_AXIS, rad ) )	
	end
end

